------------------------------------------------
-- BENDIX KING KA285 Annunciator Panel
-- version 2.0  J. ZAHAR 01/2018
-- Added blinking PA disconnect & Coupled/Armed modes
------------------------------------------------
------------- customization section ------------

display_bezel=true -- set to false to remove the bezel (for cockpit builders)
--------------end of customization section -----
--Do not modifiy beyond this point! ------------
AP_engaged=false
blink_AP=false


img_autopilot_off = img_add_fullscreen("KA285_off.png")--,0,0,512,512)
img_mask = {}
dx = {70,120,210,300,390,60,130,220,300,390,60,120,160,230,300,365}
dy = {30,30,30,30,30,70,70,70,70,70,110,110,110,110,110,110}
dw = {80,80,80,80,80,80,80,80,80,80,100,40,70,70,70,100}
dh = {30,30,30,30,30,30,30,30,30,30,60,40,50,50,50,50}

for i = 1, 16 do
    img_mask[i] = img_add_fullscreen("KA285_onjaune.png")--,0,-256,512,512)
    img_viewport_rect(img_mask[i], dx[i], dy[i], dw[i], dh[i])
    img_visible(img_mask[i], false)
end
if display_bezel==true then img_add_fullscreen("KA285_bezel.png") end


function PT_liteup(nav, armgs, armhnav, armbc, alt, ap, hdg, capgs, caphnav, capbc, toga, inner, outer, middle, trim, APstate)


 -- FD
    visible(img_mask[1], ap == 1)
 -- NAV
    visible(img_mask[2], nav > 0)
 -- ARM
    visible(img_mask[3], armgs == 1 or armhnav == 1 or armbc == 1)
 -- ALT
    visible(img_mask[4], bit32.band(APstate, 0x04000) == 16384)
 -- AP
    visible(img_mask[5], ap == 2)
 -- HDG
    visible(img_mask[6], bit32.band(APstate, 0x00002) == 2)
 -- APR
    visible(img_mask[7], caphnav > 1)
 -- CPLD (Active mode for NAV, APPR and BC)
    visible(img_mask[8], capgs == 2 or armhnav == 2 or armbc == 2)
 -- GS
    visible(img_mask[9], armgs == 2)
 -- GA
    visible(img_mask[10], toga == 2)
 -- BC
    visible(img_mask[11], armbc == 2)
 -- Outer marker
    visible(img_mask[14], outer > 0)
 -- Middle marker
    visible(img_mask[15], middle > 0)
 -- Inner marker
	visible(img_mask[13], inner > 0)
 -- Trim
    visible(img_mask[16], trim > 0)

    -- INOP  if nav > 0 then img_visible(img_mask[12], true) else img_visible(img_mask[12], false) end
end

function stop_blink_AP()
blink_AP=false
visible(img_mask[5], false)
end

function FSX_autopilot(fd, nav, alt, ap, hdg, apr, bc, gs, toga, marker, elac, fac, sec,battery,avionics,generator_left,generator_right,ffleft,ffright)
   if (battery == true and avionics==true)or (generator_left == true and ffleft > 0 and avionics==true) or (generator_right == true and ffright > 0 and avionics==true) then 
   vis=true
   else
   vis=false
   end
 -- FD
    visible(img_mask[1], fd == true and vis==true)
 -- NAV
    visible(img_mask[2], nav == true and vis==true)
 -- ARM (No ARMED modes in FSX, only active)
	visible(img_mask[3], (nav==true and hdg==true) or (apr==true and hdg==true)or (bc==true and hdg==true)  and vis==true)--or alt==true
-- armgs == 1 or armhnav == 1 or armbc == 1)
 -- ALT
    visible(img_mask[4], alt == true and vis==true)
 -- AP
    visible(img_mask[5], ap == true and vis==true)

if ap == true and vis==true then 
visible(img_mask[5],true)
AP_engaged=true
else
if AP_engaged==true then
AP_engaged=false
blink_AP=true 
timer_start(2000,nil,stop_blink_AP)
end
end

	-- HDG
    visible(img_mask[6], hdg == true and vis==true)
 -- APR
    visible(img_mask[7], apr == true and vis==true)
 -- CPLD (Active mode for NAV, APPR and BC)
	visible(img_mask[8], (nav == true and hdg==false) or (apr==true and hdg==false) or (bc==true and hdg==false)  and vis==true)--and alt==false 
 -- GS
	visible(img_mask[9], gs==true and vis==true)
 -- GA
    visible(img_mask[10], toga == true and vis==true)
 -- BC
    visible(img_mask[11], bc == true and vis==true)
-- Inner marker
	visible(img_mask[13], marker == 3 and vis==true)
 -- Outer marker
    visible(img_mask[14], marker == 1 and vis==true)
 -- Middle marker
    visible(img_mask[15], marker == 2 and vis==true)

 -- Trim
    visible(img_mask[16], (elac == true or fac == true or sec == true) and vis==true)
	
    -- INOP  if nav > 0 then img_visible(img_mask[12], true) else img_visible(img_mask[12], false) end
end

-- ------------- GENERAL BLINKING ROUTINE ---------------------

function timer_blink()

blink = not blink

if blink_AP then

	visible(img_mask[5],blink)
end

end

timer = timer_start(0, 200, timer_blink)

xpl_dataref_subscribe("sim/cockpit2/autopilot/nav status", "INT",
					  "sim/cockpit2/autopilot/glideslope_status", "INT",
					  "sim/cockpit2/autopilot/nav_status", "INT",
					  "sim/cockpit2/autopilot/backcourse_status", "INT",
					  "sim/cockpit2/autopilot/altitude_mode", "INT",
					  "sim/cockpit/autopilot/autopilot_mode", "INT", 
					  "sim/cockpit2/autopilot/heading_mode", "INT",
					  "sim/cockpit2/autopilot/glideslope_status", "INT",
					  "sim/cockpit2/autopilot/approach_status", "INT",
					  "sim/cockpit2/autopilot/backcourse_status", "INT",
					  "sim/cockpit2/autopilot/TOGA_status", "INT",
					  "sim/cockpit/misc/inner_marker_lit", "INT",
					  "sim/cockpit/misc/outer_marker_lit", "INT",
					  "sim/cockpit/misc/middle_marker_lit", "INT",
					  "sim/cockpit/warnings/annunciators/autopilot_trim_fail", "INT",
					  "sim/cockpit/autopilot/autopilot_state", "INT", PT_liteup)
fsx_variable_subscribe("AUTOPILOT FLIGHT DIRECTOR ACTIVE", "Bool",
					   "AUTOPILOT NAV1 LOCK", "Bool",
					   "AUTOPILOT ALTITUDE LOCK", "Bool",
					   "AUTOPILOT MASTER", "Bool",
					   "AUTOPILOT HEADING LOCK", "Bool",
					   "AUTOPILOT APPROACH HOLD", "Bool",
					   "AUTOPILOT BACKCOURSE HOLD", "Bool",
					   "AUTOPILOT GLIDESLOPE HOLD", "Bool",
					   "AUTOPILOT TAKEOFF POWER ACTIVE", "Bool",
					   "MARKER BEACON STATE", "Enum",
					   "FLY BY WIRE ELAC FAILED", "Bool", 
					   "FLY BY WIRE FAC FAILED", "Bool", 
					   "FLY BY WIRE SEC FAILED", "Bool",
					   "ELECTRICAL MASTER BATTERY", "Bool", 
					   "AVIONICS MASTER SWITCH","Bool",
                       "GENERAL ENG MASTER ALTERNATOR:1", "Bool", 
                       "GENERAL ENG MASTER ALTERNATOR:2", "Bool", 
                       "RECIP ENG FUEL FLOW:1", "Pounds per hour", 
                       "RECIP ENG FUEL FLOW:2", "Pounds per hour",  FSX_autopilot)
					   
				